--hm, for an addon this ended up being moderately complex after all


_G.HotlineMiamiComboCounter = HotlineMiamiComboCounter or {}

HotlineMiamiComboCounter._mod_path = ModPath
HotlineMiamiComboCounter._menu_path = HotlineMiamiComboCounter._mod_path .. "menu/options.txt"
HotlineMiamiComboCounter._localization_path = HotlineMiamiComboCounter._mod_path .. "loc/" --not used, really just for reference
HotlineMiamiComboCounter._save_path = SavePath .. "hotline_miami_combo_counter.txt"
HotlineMiamiComboCounter.COMBO_THRESHOLD_TIME = 2 --no more than 2 seconds must elapse between each kill
HotlineMiamiComboCounter.COMBO_MINIMUM_KILLS = 2
HotlineMiamiComboCounter.SCORE_INTERP_DURATION = 2
HotlineMiamiComboCounter.SCORE_INTERP_THRESHOLD = 1 --if the added score from a kill is less than or equal to this amount, update the score counter without doing the text interpolation animation (score counter ticking)


HotlineMiamiComboCounter.default_settings = {
	score_enabled = true,
	score_x = 1035,
	score_y = 160,
	score_font_size = 32,
	combo_enabled = true,
	combo_x = 0,
	combo_y = -210,
	combo_font_size = 40,
	box_visible = false,
	
	STROBE_SIZE = 25,
	BOX_W = 4, --this is multiplied with the font size and then added with BOX_W_ADDEND
	BOX_W_ADDEND = 128, --this is added on top of BOX_W
--	BOX_H = 25,
	BOX_MARGIN = 1.3, --this replaces BOX_H, and is a multiplier against the score font size
	ROT_SPEED = 256,
	COMBO_ROT_SPEED = 512,
	COMBO_ROT_DISTANCE = 1/28, --this is now a multiplier with the combo font size to get the final rot distance, making it proportional, unlike in mhp
	SCORE_ROT_DISTANCE = 1/16, --same
	COMBO_ANIM_HEIGHT = -100
}
HotlineMiamiComboCounter.settings = table.deep_map_copy(HotlineMiamiComboCounter.default_settings)

HotlineMiamiComboCounter._current_score_real = 0 --the current score
HotlineMiamiComboCounter._current_score_interp = 0 --the previous value of score when the score is changed after a kill
HotlineMiamiComboCounter._score_interp_t = 0 --the time of the last scored kill, to allow for interpolation
HotlineMiamiComboCounter._current_combo = 0
HotlineMiamiComboCounter._animate_targets = {}
HotlineMiamiComboCounter.COMBO_MACRO = "$COMBO"
HotlineMiamiComboCounter.SCORE_MACRO = "$SCORE"

HotlineMiamiComboCounter._fonts = {
	hotline = "fonts/retro_computer",
	hotline_combo = "fonts/justice"
}

function HotlineMiamiComboCounter.interp_colors(one,two,percent) --interpolates colors based on a percentage
--percent is [0,1]
	percent = math.clamp(percent,0,1)
	
--color 1
	local r1 = one.red
	local g1 = one.green
	local b1 = one.blue
	local a1 = one.alpha
	
--color 2
	local r2 = two.red
	local g2 = two.green
	local b2 = two.blue
	local a2 = two.alpha

--delta
	local r3 = r2 - r1
	local g3 = g2 - g1
	local b3 = b2 - b1
	local a3 = a2 - a1
	
	return Color(r1 + (r3 * percent),g1 + (g3 * percent), b1 + (b3 * percent)):with_alpha(a1 + (a3 * percent))
end

function HotlineMiamiComboCounter.angle_from(a,b,c,d) -- converts to angle with ranges (-180 , 180); for result range 0-360, do +180 to result
--mvector3.angle() is a big fat meanie zucchini;
	a = a or "nil"
	b = b or "nil"
	c = c or "nil"
	d = d or "nil"
	local function do_angle(x1,y1,x2,y2)
		local angle = 0
		local x = x2 - x1 --x diff
		local y = y2 - y1 --y diff
		if x ~= 0 then 
			angle = math.atan(y / x) % 180
			if y == 0 then 
				if x > 0 then 
					angle = 180 --right
				else
					angle = 0 --left 
				end
			elseif y > 0 then 
				angle = angle - 180
			end
		else
			if y > 0 then
				angle = 270 --up
			else
				angle = 90 --down
			end
		end
		
		return angle
	end
	local vectype = type(Vector3())
	if (type(a) == vectype) and (type(b) == vectype) then  --vector pos diff
		return do_angle(a.x,a.y,b.x,b.y)
	elseif (type(a) == "number") and (type(b) == "number") and (type(c) == "number") and (type(d) == "number") then --manual x/y pos diff
		return do_angle(a,b,c,d)
	else
		return
	end
end

HotlineMiamiComboCounter.color_data = {
	hlm_1 = Color(1,1,1),
	hlm_2 = Color(0,1,1),
	hlm_3 = Color(1,0,1)
}


HotlineMiamiComboCounter.color_strobes = {
	hotline_miami = {
		raw = { HotlineMiamiComboCounter.color_data.hlm_1,HotlineMiamiComboCounter.color_data.hlm_2,HotlineMiamiComboCounter.color_data.hlm_3 },
		processed = {}
	}
}


local strobe_size = HotlineMiamiComboCounter.settings.STROBE_SIZE
for name,item in pairs(HotlineMiamiComboCounter.color_strobes) do
	local raw = item.raw or {}
	for i,color_1 in ipairs(raw) do 
		local color_2
		if i < #raw then
			color_2 = raw[i + 1]
		else
			color_2 = raw[1]
		end
		for i=1,strobe_size do 
			table.insert(item.processed,HotlineMiamiComboCounter.interp_colors(color_1,color_2,i/strobe_size))
		end
	end
end


function HotlineMiamiComboCounter:CreateHUD(hud)
	local hotline_hud = hud:panel({
		name = "hlmcc_panel"
	})
	self._panel = hotline_hud
	
	local data = self.settings
--	local scale = data.SCALE
	local score_font_size = data.score_font_size
	local combo_font_size = data.combo_font_size
	local BOX_W = (data.BOX_W * score_font_size) + data.BOX_W_ADDEND
	local BOX_H = score_font_size * data.BOX_MARGIN --data.BOX_H * scale
--	local score_label_offset_x = -score_font_size / 2
--	local score_label_offset_y = score_font_size / 8
	
	local combo_text = hotline_hud:text({
		name = "combo_text",
		text = "2x combo",
		x = 0,
		y = 0,
		align = "center",
		vertical = "top",
		font = self._fonts.hotline_combo,
		font_size = combo_font_size,
		color = Color.white,
		layer = 4,
		visible = false
	})
	
	local combo_text_shadow = hotline_hud:text({
		name = "combo_text_shadow",
		text = "2x combo",
		x = 0,
		y = 0,
		align = "center",
		vertical = "top",
		font = self._fonts.hotline_combo,
		font_size = combo_font_size,
		color = Color.white,
		layer = 4,
		visible = false
	})
	
	local score = hotline_hud:panel({
		name = "score",
		w = BOX_W,
		h = BOX_H,
		x = self:GetScoreX(), --hotline_hud:w() - BOX_W,
		y = self:GetScoreY(), --160
		visible = self:IsScoreEnabled()
	})
	self._score_panel = score
	local score_box = score:rect({
		name = "score_box",
		color = Color.black,
		visible = self.settings.box_visible,
--		alpha = 0.3,
		layer = 1
	})
	
	local score_label_front = score:text({
		name = "score_label_front",
		text = "12020pts",
--		x = score_label_offset_y,
--		y = score_label_offset_y,
		rotation = 15,
		align = "center",
		vertical = "top",
		font = self._fonts.hotline,
		font_size = score_font_size,
		color = Color.white,
		layer = 3,
		visible = true
	})
	local score_label_back = score:text({ --position of the back score label doesn't matter since it's set in AnimateHotlineMiamiScore()
		name = "score_label_back",
		text = "12020pts",
		x = 5,
--		align = 'center',
--		y = score_label_front:y() + 15,
		rotation = 15,
		align = "center",
		vertical = "top",
		font = self._fonts.hotline,
		font_size = score_font_size,
		color = Color.white,
		layer = 2,
		visible = true
	})
end

function HotlineMiamiComboCounter:SetScoreLabel(score) --not used
	self._score_panel:child("score_label_front"):set_text(score)
	self._score_panel:child("score_label_back"):set_text(score)
end

function HotlineMiamiComboCounter:GetInterpolatedScore()
	local t = Application:time()
	local i_t = self._score_interp_t
	local d_t = t - i_t
	local duration = self.SCORE_INTERP_DURATION
	local s = self._current_score_real
	
	if d_t > duration then 
		return s
	end
	
	local i_s = self._current_score_interp
	local d_s = s - i_s
	
	
	return i_s + (d_s * d_t / duration)
end

--getters; mostly unused, but functional

function HotlineMiamiComboCounter:IsScoreEnabled()
	return self.settings.score_enabled
end

function HotlineMiamiComboCounter:IsComboEnabled()
	return self.settings.combo_enabled
end

function HotlineMiamiComboCounter:GetScoreX()
	return self.settings.score_x
end

function HotlineMiamiComboCounter:GetScoreY()
	return self.settings.score_y
end

function HotlineMiamiComboCounter:GetComboX()
	return self.settings.combo_x
end

function HotlineMiamiComboCounter:GetComboY()
	return self.settings.combo_y
end

function HotlineMiamiComboCounter:GetScoreFontSize()
	return self.settings.score_font_size
end

function HotlineMiamiComboCounter:GetComboFontSize()
	return self.settings.combo_font_size
end


Hooks:Add("BaseNetworkSessionOnLoadComplete","hlmcc_ongameloadcomplete",function()
	if managers.hud then
		local ws = managers.hud._saferect
		HotlineMiamiComboCounter._ws = ws
		HotlineMiamiComboCounter:CreateHUD(ws:panel())
--		HotlineMiamiComboCounter:CreateHUD(managers.hud._hud.panel)
	
	
	--[[
		if alive(self._panel) then 
			self:SetHUDXY()
			self:SetHUDVisible()
		end
		--]]
	end
	
	BeardLib:AddUpdater("hlmcc_update",callback(HotlineMiamiComboCounter,HotlineMiamiComboCounter,"Update"))
end)

function HotlineMiamiComboCounter:OnKill(current_score,added_score)
	if added_score and added_score > 0 and self:IsComboEnabled() then 
		self._current_combo = self._current_combo + 1
		
		managers.enemy:remove_delayed_clbk("hlmcc_onkill_setombotimer",true)
		managers.enemy:add_delayed_clbk(
			"hlmcc_onkill_setombotimer",
			callback(self,self,"OnComboEnded"),
			Application:time() + self.COMBO_THRESHOLD_TIME
		)
	end
	
	if added_score and added_score > self.SCORE_INTERP_THRESHOLD then 
		self._current_score_interp = self:GetInterpolatedScore()
		self._current_score_real = current_score or self._current_score_real
	else
		self._current_score_real = current_score or self._current_score_real
		self._current_score_interp = self._current_score_real
	end
	self._score_interp_t = Application:time()
end

Hooks:Add("JoyScoreCounter_SetScore","hlmcc_on_kill",callback(HotlineMiamiComboCounter,HotlineMiamiComboCounter,"OnKill"))


function HotlineMiamiComboCounter:Update(t,dt)
	if not alive(self._panel) then 
		return
	end
	self:UpdateAnimate(t,dt)
	self:AnimateHotlineMiamiScore(t,dt)
end

function HotlineMiamiComboCounter:OnComboEnded()
	if self._current_combo > self.COMBO_MINIMUM_KILLS then 
		self:AnimateHotlineMiamiCombo(self._current_combo)
	end
	self._current_combo = 0
end


		--hud animation functions

function HotlineMiamiComboCounter:UpdateAnimate(t,dt)
	for id,data in pairs(self._animate_targets) do 
		if data and data.target and ((type(data.target) == "number") or alive(data.target)) then 
			local result = data.func(data.target,t,dt,data.start_t,unpack(data.params or {}))
			if result then 
				if type(data.done_cb) == "function" then 
					local done_cb = data.done_cb
					local target = data.target
					local params = data.params
					self._animate_targets[id] = nil
					done_cb(target,unpack(params))
--					data.done_cb(data.target,unpack(data.params))
				else
					self._animate_targets[id] = nil
				end
			end
		else
			self._animate_targets[id] = nil
		end
	end
end

function HotlineMiamiComboCounter:AnimateWait(duration,done_cb,...)
	self._waits = self._waits + 1
	self:animate(self._waits,self.animate_wait,done_cb,duration,...)
	return self._waits
end

function HotlineMiamiComboCounter:animate(target,func,done_cb,...)
	if target then 
		if type(func) == "function" then 
		elseif type(self[tostring(func)]) == "function" then
			func = self[tostring(func)]
		else
			--error!
			return
		end
		if (type(target) == "number") or alive(target) then
			self._animate_targets[tostring(target)] = {
				func = func,
				target = target,
				start_t = Application:time(),
				done_cb = done_cb,
				params = {
					...
				}
			}
		end
	end
end

function HotlineMiamiComboCounter:animate_stop(name,do_cb)
	name = tostring(name)
	local item = self._animate_targets[name]
	if item and do_cb and (type(item.done_cb) == "function") then 
		self._animate_targets[name] = nil
		return item.done_cb(item.target,unpack(item.params))
	end
end

function HotlineMiamiComboCounter:AnimateHotlineMiamiScore(t,dt)
	if alive(self._panel) then 
		local score_panel = self._score_panel
		local label_1 = score_panel:child("score_label_front")
		local label_2 = score_panel:child("score_label_back")
		local max_angle = 10
		local distance = self.settings.score_font_size * self.settings.SCORE_ROT_DISTANCE
		local rot_speed = self.settings.ROT_SPEED
		local angle = math.sin(t * rot_speed) * max_angle
		label_1:set_rotation(angle)
		label_2:set_rotation(angle)
		label_2:set_position(label_1:x() + (math.sin(t * rot_speed) * distance),label_1:y() + (math.cos(t * rot_speed) * distance))
		
		local col_table = self.color_strobes.hotline_miami.processed
		local col_t = math.floor(t * 10)
		local col_1 = col_table[col_t % #col_table]
		local col_2 = col_table[(col_t + math.floor(#col_table / 2)) % #col_table]
		if col_1 then 
			label_1:set_color(col_1)
		end
		if col_2 then 
			label_2:set_color(col_2)
		end
		
		
		local score = string.gsub(managers.localization:text("hlmcc_hud_score"),self.SCORE_MACRO,string.format("%i",self:GetInterpolatedScore()))
		label_1:set_text(score)
		label_2:set_text(score)
	end
end

function HotlineMiamiComboCounter:AnimateHotlineMiamiCombo(num) --starts animate
	local data = self.settings
	local panel = self._panel
	local text = string.upper(string.gsub(managers.localization:text("hlmcc_hud_combo"),self.COMBO_MACRO,num))
	
	local combo = panel:child("combo_text")
	local shadow = panel:child("combo_text_shadow")
	combo:set_text(text)
	shadow:set_text(text)
	
	combo:set_font_size(data.combo_font_size)
	shadow:set_font_size(data.combo_font_size)
	
	local last_pos = Vector3()
	
	local screen_pos = self._ws:world_to_screen(managers.viewport:get_current_camera(),last_pos)
--	combo:set_position(screen_pos.x,screen_pos.y)
--	shadow:set_position(screen_pos.x,screen_pos.y)
	combo:set_position(screen_pos.x,screen_pos.y)
	shadow:set_position(screen_pos.x,screen_pos.y)
	
	combo:show()
	shadow:show()
	self:animate(panel,"animate_hlm_combo",
		function()
			self:animate(combo,"animate_fade_resize_text",Text.hide,0.25,combo:font_size(),0,nil,nil,nil,nil,2)
			self:animate(shadow,"animate_fade_resize_text",Text.hide,0.25,shadow:font_size(),0,nil,nil,nil,nil,2)
		end,
		2,last_pos,data.COMBO_ANIM_HEIGHT
	)
end

function HotlineMiamiComboCounter.animate_fade_resize_text(o,t,dt,start_t,duration,from_size,to_size,from_alpha,to_alpha,center_x,center_y,power)
	local ratio = (t - start_t) / duration
	local should_end = false
	if ratio >= 1 then 
		should_end = true
		ratio = 1
	end
	ratio = math.pow(ratio,power or 2)
	
	if from_size and to_size then
		o:set_font_size(from_size + ((to_size - from_size) * ratio))
	end
	if from_alpha and to_alpha then 
		o:set_font_size(from_alpha + ((to_alpha - from_alpha) * ratio))
	end
	
	if center_x and center_y then 
		o:set_center(center_x,center_y)
	end
	
	if should_end then 
		return true
	end
end

function HotlineMiamiComboCounter.animate_hlm_combo(o,t,dt,start_t,duration,start_pos,d_y,power)
	
	local data = HotlineMiamiComboCounter.settings
	local panel = HotlineMiamiComboCounter._panel
	
	local combo = panel:child("combo_text")
	local shadow = panel:child("combo_text_shadow")
	
	local ratio = (t - start_t) / duration
	local should_end = false
	if ratio >= 1 then 
		ratio = 1
		should_end = true
	end
	ratio = math.pow(ratio,power or 2)
	
	local col_table = HotlineMiamiComboCounter.color_strobes.hotline_miami.processed
	local col_t = math.floor(t * 100)
	
	local col_1 = col_table[col_t % #col_table]
	local col_2 = col_table[(col_t + math.ceil(#col_table / 10)) % #col_table]
	if col_1 then 
		combo:set_color(col_1)
	end
	if col_2 then 
		shadow:set_color(col_2)
	end
	
	local distance = data.COMBO_ROT_DISTANCE * data.combo_font_size
	local rot_speed = data.COMBO_ROT_SPEED
	
	local viewport_cam = managers.viewport:get_current_camera()
	if not alive(viewport_cam) then 
		return true
	end
	
	local aim = viewport_cam:rotation():yaw()
	local my_pos = viewport_cam:position()	
	--[[
		--joyscore doesn't pass, or itself have, a reference to the unit that you have killed- only the name of the unit type
		--that means that positional data is not available like it is in the original version of the hlm combo counter in mhp, 
		--and that in turn means that i can't make the popup appear where you killed the unit
		
		--i'll try and figure out a solution but for now you get this workaround
		
	local angle_from = (180 + aim - HotlineMiamiComboCounter.angle_from(start_pos.x,start_pos.y,my_pos.x,my_pos.y)) % 360
	if math.abs(90 - angle_from) > 90 then
		combo:set_position(-1000,-1000)
		shadow:set_position(-1000,-1000)
	else
	--]]
		
		local center_x,center_y = panel:center()
		local screen_pos = {x = center_x + data.combo_x,y = center_y + data.combo_y} --HotlineMiamiComboCounter._ws:world_to_screen(viewport_cam,start_pos)
		local x_1 = screen_pos.x - (panel:w() / 2)
		local y_1 = screen_pos.y + (d_y * ratio)
		
		combo:set_x(x_1 + (math.sin(t * rot_speed) * distance))
		combo:set_y(y_1 + (math.cos(t * rot_speed) * distance))
		
		shadow:set_x(x_1 - (math.sin(t * rot_speed) * distance))
		shadow:set_y(y_1 - (math.cos(t * rot_speed) * distance))
--	end
	
	combo:set_font_size(data.combo_font_size * (1 + (ratio * 0.5)))
	shadow:set_font_size(data.combo_font_size * (1 + (ratio * 0.5)))
	
	
	if should_end then 
		return true
	end
end

		--menu
function HotlineMiamiComboCounter:Load()
	local file = io.open(HotlineMiamiComboCounter._save_path, "r")
	if (file) then
		for k, v in pairs(json.decode(file:read("*all"))) do
			HotlineMiamiComboCounter.settings[k] = v
		end
	else
		HotlineMiamiComboCounter:Save()
	end
end

function HotlineMiamiComboCounter:Save()
	local file = io.open(HotlineMiamiComboCounter._save_path,"w+")
	if file then
		file:write(json.encode(HotlineMiamiComboCounter.settings))
		file:close()
	end
end

function HotlineMiamiComboCounter:PromptResetSettings()
	QuickMenu:new(managers.localization:text("hlmcc_menu_prompt_reset_settings_title"),managers.localization:text("hlmcc_menu_prompt_reset_settings_desc"),{
		{
			text = managers.localization:text("hlmcc_menu_cancel"),
			is_focused_button = true,
			is_cancel_button = true
		},
		{
			text = managers.localization:text("hlmcc_menu_confirm"),
			is_highlighted = true,
			callback = callback(self,self,"ResetSettings")
		}
	},true)
end

function HotlineMiamiComboCounter:ResetSettings()
	self.settings = self.default_settings
	self:Save()
end

Hooks:Add( "MenuManagerInitialize", "hlmcc_MenuManagerInitialize", function(menu_manager)
	MenuCallbackHandler.callback_hlmcc_set_score_enabled = function(self,item)
		local value = item:value() == "on"
		HotlineMiamiComboCounter.settings.score_enabled = value
		if alive(HotlineMiamiComboCounter._score_panel) then 
			HotlineMiamiComboCounter._score_panel:set_visible(value)
		end
		HotlineMiamiComboCounter:Save()
	end
	MenuCallbackHandler.callback_hlmcc_set_score_x = function(self,item)
		local value = tonumber(item:value())
		HotlineMiamiComboCounter.settings.score_x = value
		if alive(HotlineMiamiComboCounter._score_panel) then 
			HotlineMiamiComboCounter._score_panel:set_x(value)
		end
		HotlineMiamiComboCounter:Save()
	end
	MenuCallbackHandler.callback_hlmcc_set_box_visible = function(self,item)
		local value = item:value() == "on"
		HotlineMiamiComboCounter.settings.box_visible = value
		if alive(HotlineMiamiComboCounter._score_panel) then 
			HotlineMiamiComboCounter._score_panel:child("score_box"):set_visible(value)
		end
		HotlineMiamiComboCounter:Save()
	end
	MenuCallbackHandler.callback_hlmcc_set_score_y = function(self,item)
		local value = tonumber(item:value())
		HotlineMiamiComboCounter.settings.score_y = value
		if alive(HotlineMiamiComboCounter._score_panel) then 
			HotlineMiamiComboCounter._score_panel:set_y(value)
		end
	end
	MenuCallbackHandler.callback_hlmcc_set_score_font_size = function(self,item)
		local value = tonumber(item:value())
		HotlineMiamiComboCounter.settings.score_font_size = tonumber(item:value())
		if alive(HotlineMiamiComboCounter._score_panel) then 
			HotlineMiamiComboCounter._score_panel:child("score_label_front"):set_font_size(value)
			HotlineMiamiComboCounter._score_panel:child("score_label_back"):set_font_size(value)
			local score_box = HotlineMiamiComboCounter._score_panel:child("score_box")
			score_box:set_w((value * HotlineMiamiComboCounter.settings.BOX_W) + HotlineMiamiComboCounter.settings.BOX_W_ADDEND)
			score_box:set_h(value * HotlineMiamiComboCounter.settings.BOX_MARGIN)
		end
		HotlineMiamiComboCounter:Save()
	end
	MenuCallbackHandler.callback_hlmcc_set_combo_enabled = function(self,item)
		local value = item:value() == "on"
		HotlineMiamiComboCounter.settings.combo_enabled = value
		if managers.enemy and not value then 
			managers.enemy:remove_delayed_clbk("hlmcc_onkill_setombotimer",true)
		end
		HotlineMiamiComboCounter:Save()
	end
	MenuCallbackHandler.callback_hlmcc_set_combo_x = function(self,item) --disabled
		local value = tonumber(item:value())
		HotlineMiamiComboCounter.settings.combo_x = value
		HotlineMiamiComboCounter:AnimateHotlineMiamiCombo(0)
		HotlineMiamiComboCounter:Save()
	end
	MenuCallbackHandler.callback_hlmcc_set_combo_y = function(self,item) --disabled
		local value = tonumber(item:value())
		HotlineMiamiComboCounter.settings.combo_y = value
		HotlineMiamiComboCounter:AnimateHotlineMiamiCombo(0)
		HotlineMiamiComboCounter:Save()
	end
	MenuCallbackHandler.callback_hlmcc_set_combo_font_size = function(self,item)
		local value = tonumber(item:value())
		HotlineMiamiComboCounter.settings.combo_font_size = value
--		if alive(HotlineMiamiComboCounter._panel) then 
--			HotlineMiamiComboCounter._panel:child("combo_text"):set_font_size(value)
--			HotlineMiamiComboCounter._panel:child("combo_text_shadow"):set_font_size(value)
--		end
		HotlineMiamiComboCounter:AnimateHotlineMiamiCombo(0)
		HotlineMiamiComboCounter:Save()
	end
	MenuCallbackHandler.callback_hlmcc_reset_settings = function(self)
		HotlineMiamiComboCounter:PromptResetSettings()
	end
	
	MenuCallbackHandler.callback_hlmcc_close = function(this)
--		HotlineMiamiComboCounter:Save()
	end
	
	HotlineMiamiComboCounter:Load()
	
	MenuHelper:LoadFromJsonFile(HotlineMiamiComboCounter._menu_path, HotlineMiamiComboCounter, HotlineMiamiComboCounter.settings)
	
end)
